<bugID>1382899<Summary>Reduce Promise overhead in the DownloadLegacy.js progress events</Summary><Description>I think this is related to downloads but I am not 100% sure.

It seems every time I download a file from a specific site (hard to give access, but I can tell the download is exteemely slow like 140 KB/sec) Firefox seems to slow down up to a point where I get beachballing and my cursor stops moving smoothly.

Couple of observations:

- the download itself is pretty slow. I'm on 100 Mbit but this comes in at 140 KB/sec.
- the server is not providing a content-length or an incorrect content length .. the download manager does not show the actul size and it shows an indeterminate spinner
- The download is marked as 34 MB on the page but in reality is 77 MB
- while the download happens i can barely type in this text field in bugzilla

I'm a Mac Pro with 64 GB of which half free, running OS X 10.12.6 and Today's Nightly.</Description></bugID>